#-*- coding:utf-8 -*-

"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""

import sys
sys.setdefaultencoding('utf-8')

__script__ = 'PyMusicSP'
__version__ = '0.02'
__author__ = 'masa'
__web__ = 'http://masaland.cocolog-nifty.com/'
#__Copyright__ = 'Copyright (c) 2009-2010 masa'
__Copyright__ = '(c) 2009-2010 masa'

#  Change this part According to your environment
ini_file = u'E:\\Data\\masa\\PyMusicSP.ini'
lst_file = u'E:\\Data\\masa\\PyMusicSP.lst'
wakeup_music = 'E:\\Sounds\\Simple\\Bach.aac'
m_volume = 3
option   = 0
"""
option:
 0: random       & single
 1: random       & all
 2: sequentially & single   <- only first music in list
 3: sequentially & all
description
  2^0 bit:  0:single play           1:play all in list
  2^1 bit:  0:play in random order  1:play sequentially
"""
#  /end
exit_play    = 0 # global, exit control flag
skip_music   = 0 # global, skip control flag
current_index= 0 # global, index number of playing music
entries      = [] # global, list for ListBox

import e32
import os
import audio
import random
import appuifw
import re
#from key_codes import EKeyIncVolume
#from key_codes import EKeyDecVolume
from key_codes import EKeyUpArrow
from key_codes import EKeyDownArrow
from key_codes import EKeyLeftArrow
from key_codes import EKeyRightArrow

script_lock = e32.Ao_lock()

def confread():
  global lst_file
  global option
  global m_volume

  try:
    F = open(ini_file,'r')
    FData = F.read()
    F.close
  except:
    return

  FData = unicode(FData)
  lnDatalist = FData.split(u"\n")
  for lnData in lnDatalist:
    lnDtatwk = re.sub(u"[ \t]+",u" ",lnData)
    confData=lnDtatwk.split(u" ")
    if len(confData) < 2 :continue # no confData[1]
    if confData[0]   == u"lst_file":  lst_file = (confData[1])
    elif confData[0] == u"m_volume":  m_volume = int(confData[1])
    elif confData[0] == u"option"  :  option   = int(confData[1])

def stop_music():
    global exit_play
    exit_play = 1
    script_lock.signal()

def skip_music():
    global skip_music
    skip_music = 1
    script_lock.signal()

def cb(prev, curr, err):
    if curr == 1: script_lock.signal()

def go_playing():
    listbox.set_list(entries, current_index)

def Inc_Volume():
    global m_volume
    if m_volume < 11: m_volume = m_volume + 1
    s.set_volume(m_volume)

def Dec_Volume():
    global m_volume
    if m_volume > 0: m_volume = m_volume - 1
    s.set_volume(m_volume)

def about():
    """
    msg = ('App Name : ' + __script__ + '\n') + \
			('Version : ' + __version__ + '\n') + \
			('Author : ' + __author__ + '\n' ) + \
			(__web__  + '\n') + \
			(__Copyright__)
    appuifw.note(unicode(msg, "utf-8"), "info", True)
    """
    msg =   ('App : ' + __script__ + '\n') + \
			('Version : ' + __version__ + '\n') + \
			(__Copyright__ + '\n') + \
			(__web__ )
    appuifw.query(unicode(msg, "utf-8"), "query")



# main process
confread() #set config data

try :
    f = open(lst_file,'r')
    fData = f.read()
    f.close
except :
    fData = wakeup_music

fData = unicode(fData)

music_list = [x.strip() for x in fData.split(u"\n") \
              if x.strip() != '' and x.strip()[0] != u'#' \
              and os.path.isfile(x.strip())]

if len(music_list) == 0:
    appuifw.note(u"no data in playlist", "error")
    music_list = [unicode(wakeup_music)]

musics = []
if option == 0: # random   single
    musics.append(music_list[random.randint(0, (len(music_list) - 1))])

elif option == 1: # random  all
    while music_list:
        n = random.randint(0, (len(music_list) - 1))
        musics.append(music_list[n])
        del music_list[n]

elif option == 2: # sequentially single
    musics.append(music_list[0])

elif option == 3: # sequentially all
    musics = music_list

old_title = appuifw.app.title
appuifw.app.title = unicode((__script__ + ' ' +__version__),'UTF-8')
appuifw.app.menu = [(u'Skip',skip_music),
					(u'Stop', stop_music),
					(u'Go to now playing', go_playing),
					(u'Volume',
						((u'Increase  (/-->)', Inc_Volume),
						 (u'Decrease (/<--)', Dec_Volume))),
					(u'About', about)]
appuifw.app.exit_key_handler = lambda:stop_music()

entries = [('  ' + os.path.split(x)[1]) for x in musics]
listbox = appuifw.Listbox(entries, lambda:None)
#listbox.bind(EKeyIncVolume, lambda: Inc_Volume())
#listbox.bind(EKeyDecVolume, lambda: Dec_Volume())
listbox.bind(EKeyRightArrow, lambda: Inc_Volume())
listbox.bind(EKeyLeftArrow, lambda: Dec_Volume())
appuifw.app.body = listbox

for x in range(len(musics)):
    current_index = x
    MUSIC = musics[x] # get music_path

    """
    演奏中の曲の先頭に＊を表示する
    """
    if x > 0:
        work = u'  ' + entries[x-1][2:]
        entries[x-1] = work
    work = u'* ' + entries[x][2:]
    entries[x] = work

    listbox.set_list(entries, x)

    s = audio.Sound.open(MUSIC)
    s.set_volume(m_volume)
    s.play(1, 0, cb)
    script_lock.wait()

    if skip_music == 1:
        skip_music = 0
        s.stop()
    if exit_play == 1:
        s.stop()
        break

appuifw.app.title = old_title

#appuifw.app.set_exit()
#sys.exit()
